
/*
------- CHANGELOG --------------------------------------------------------------

	2007-09-15  Kim A. Brandt <kimabrandt@gmx.de>
	* 12291.user.js (youtube.com): Allow to watch YouTube videos and browse
	the `Related' list.

	2007-09-16  Kim A. Brandt <kimabrandt@gmx.de>
	* 12291.user.js (RELATED VIDEOS): Allow to browse the `Related Videos'
	list.

	2007-09-17  Kim A. Brandt <kimabrandt@gmx.de>
	* 12291.user.js (main): Added support for the sites `vids.myspace.com'
	and `video.google.com'.

	2007-09-19  Kim A. Brandt <kimabrandt@gmx.de>
	* 12291.user.js (main): Added support for the site `metacafe.com'.

------- COMMENTS ---------------------------------------------------------------

	<b>If you like JavaScript and are not worried about its use you won't
	need this script.</b>

	I am open for site suggestions. Tell me what functionality you would
	like to use on a site and I will see what I can/will do.
	  Actually I hope there is an interest in disabling JavaScript and to
	create/extend scripts to adjust site contents to our likings.
	  If you have some ideas or you know about a project which deals with
	this subject (no JavaScript and change site contents) let me know.
*/

function main()
{
	switch(window.location.host)
	{
		// metacafe.com
		case "www.metacafe.com":
			www_metacafe_com();
			break;

		// myspace.com
		case "vids.myspace.com":
			vids_myspace_com();
			break;

		// google.com
		case "video.google.com":
			video_google_com();
			break;

		// youtube.com
		case "youtube.com":
		case "www.youtube.com":
			youtube_com();
			break;
	}
}

function www_metacafe_com()
{
	var scripts = getScripts();
	for (var i = 0; i < scripts.snapshotLength; i++)
	{
		var script = scripts.snapshotItem(i).firstChild;
		if (!script) continue;
		script = script.nodeValue;

		// FLASHCONTENT
		if (script.search(/var\ so/) > -1)
		{
			var src = script.match(/var\ so.*/)[0].match(/http:\/\/[^"]+/)[0];
			var flashvars = script.match(/so\.addParam\(\"flashvars.*/)[0].match(/itemID=[^"]+/)[0];
			var element = document.getElementById("FlashObj");
			element.innerHTML = "<embed id=\"fpObj\" width=\"100%\" height=\"100%\" flashvars=\"" + flashvars + "\" quality=\"high\" name=\"fpObj\" src=\"" + src + "\" type=\"application/x-shockwave-flash\"/>";
			return;
		}
	}
}

function vids_myspace_com()
{
	var scripts = getScripts();
	for (var i = 0; i < scripts.snapshotLength; i++)
	{
		var script = scripts.snapshotItem(i).firstChild;
		if (!script) continue;
		script = script.nodeValue;

		// FLASHCONTENT
		if (script.search(/var\ so/) > -1)
		{
			var m = script.match(/var\ m.*/)[0].match(/[0-9]+/)[0];
			var src = script.match(/var\ s.*/)[0].match(/http:\/\/[^"]+/)[0];
/*			var element = document.getElementById("flashcontent");
			if (!element)*/ element = document.getElementById("videoPlayerComponent");
			element.innerHTML = "<embed id=\"vplayer\" width=\"480\" height=\"386\" flashvars=\"m=" + m + "\" quality=\"high\" name=\"vplayer\" src=\"" + src + "\" type=\"application/x-shockwave-flash\"/>";
			return;
		}
	}
}

function video_google_com()
{
	// GENRE PAGE
	var tables = document.evaluate(".//table[contains(@style, 'visibility: hidden;')]", document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (tables && tables.snapshotLength > 0) for (var i = 0; i < tables.snapshotLength; i++) tables.snapshotItem(i).setAttribute("style", "");

	// GOOGLE VIDEOS
	var noscriptflash = document.getElementById("noscriptflash");
	if (noscriptflash)
	{
		var thirdPartyFrame = document.getElementById("3rdPartyFrame");
		thirdPartyFrame.parentNode.removeChild(thirdPartyFrame);
		noscriptflash.setAttribute("style", "margin: 0; width: 450px; height: 370px;");
		document.getElementById("VideoPlayback").setAttribute("style", "width: 450px; height: 370px;");
	}

	var scripts = getScripts();
	for (var i = 0; i < scripts.snapshotLength; i++)
	{
		var script = scripts.snapshotItem(i).firstChild;
		if (!script) continue;
		script = script.nodeValue;

		// 3RD PARTY VIDEOS
		if (!noscriptflash && script.search(/function\ init/) > -1)
		{
			var src = script.match(/ele\('3rdPartyFrame'\)\.src.*/)[0];
			start = src.indexOf("\"");
			stop = src.lastIndexOf("\"");
			src = src.substring(start+1, stop);
			src = src.replace(/\\u003d/ig, "=");
			window.location.replace(src);
		}

		// SHOW RELATED
		if (noscriptflash && script.search(/function\ showRelated/) > -1)
		{
			// RELATED URL
			var showRelated = script.match(/function\ showRelated[^}]+/)[0];
			var parameters = showRelated.match(/\+\ \"[^"]+/g);
			var related = "http://video.google.com/videorelated";
			for (var i = 0; i < parameters.length; i++) related += parameters[i].substring(3);
			related += "&q=";

			// XMLHttpRequest
			var request = new XMLHttpRequest();
			request.open("GET", related, false);
			request.send(null);
			if (request.status != 200) continue;
			var doc = request.responseText;

			// RELATED VIDEOS
			var relatedVideos = document.getElementById("related-videos");
			var thumbstrip = document.createElement("div");
			thumbstrip.setAttribute("class", "related_videos_thumbstrip_div");
			relatedVideos.innerHTML = "";
			relatedVideos.appendChild(thumbstrip);
			var lines = doc.match(/\-?[0-9]{19}.*/g);
			for (var i = 0; i< lines.length; i++)
			{
				// ID
				var tmp = lines[i];
				var index = tmp.search(/\s/);
				var id = tmp.substring(0, index);

				// SRC
				index = tmp.indexOf("http://");
				tmp = tmp.substring(index);
				var index = tmp.search(/\s/);
				var src = tmp.substring(0, index);

				// ALT
				index = src.length;
				tmp = escape(tmp.substring(index));
				index = tmp.search(/%20/);
				tmp = tmp.substring(index);
				index = tmp.search(/%09/);
				var alt = unescape(tmp.substring(0, index));

				// TITLE
				tmp = unescape(tmp.substring(index));
				index = tmp.search(/[0-9 ]*(Std\.|Min\.)/);
				var title = tmp.substring(0, index);

				// HREF
				index = tmp.indexOf("/url?docid=");
				tmp = tmp.substring(index);
				var index = tmp.search(/\s/);
				var href = tmp.substring(0, index);
				thumbstrip.innerHTML +=
"<div class=\"related_video_thumb\">" +
"<center>" +
"<table cellspacing=\"0\" cellpadding=\"0\">" +
"<tbody>" +
"<tr>" +
"<td valign=\"bottom\" height=\"62\" align=\"center\">" +
"<div id=\"favicon" + id + "\" style=\"border: 1px solid blue; position: relative; width: 80px; height: 60px; background-color: black;\">" +
"<a href=\"" + href + "\" rel=\"nofollow\">" +
"<img style=\"border: medium none ; width: 80px; height: 60px; margin-left: 0px; margin-top: 0px;\" title=\"" + title + "\" alt=\"" + alt + "\" src=\"" + src + "\"/>" +
"</a>" +
"</div>" +
"</td>" +
"</tr>" +
"<tr>" +
"<td valign=\"top\" align=\"center\">" +
"<div>" +
"<a href=\"" + href + "\" rel=\"nofollow\" title=\"" + title + "\">" + alt + "</a>" +
"</div>" +
"</td>" +
"</tr>" +
"</tbody>" +
"</table>" +
"</center>" +
"</div>";
			}
		}
	}
}

function youtube_com()
{
	var scripts = getScripts();
	for (var i = 0; i < scripts.snapshotLength; i++)
	{
		var script = scripts.snapshotItem(i).firstChild;
		if (!script) continue;
		script = script.nodeValue;

		// PLAYERDIV
		if (script.search(/var\ swfArgs/) > -1)
		{
			// FLASHVARS
			var flashvars = script.match(/var\ swfArgs.*/)[0];
			start = flashvars.indexOf("{");
			stop = flashvars.lastIndexOf("}");
			flashvars = flashvars.substring(start+1, stop-1);
			flashvars = flashvars.replace(/:'/g, "=");
			flashvars = flashvars.replace(/',/g, "&");
			flashvars += "&playnext=0";

			// SRC
			var src = script.match(/var\ swfUrl.*/)[0];
			start = src.indexOf("'");
			stop = src.lastIndexOf("'");
			src = src.substring(start+1, stop);
			var playerDiv = document.getElementById("playerDiv");
			playerDiv.innerHTML = "<embed id=\"movie_player\" width=\"450\" height=\"370\" flashvars=\"" + flashvars + "\" allowfullscreen=\"true\" quality=\"high\" bgcolor=\"#FFFFFF\" name=\"movie_player\" style=\"\" src=\"" + src + "\" type=\"application/x-shockwave-flash\"/>";
			continue;
		}

		// RELATED 1/2
		if (script.search(/function\ render_full_side/) > -1)
		{
			script += "render_full_side();";
			eval(script);
			continue;
		}
	}

	// RELATED 2/2
	var sideResults = document.getElementById("side_results");
	if (sideResults)
	{
		var script = sideResults.getAttribute("onscroll");
		eval(script);
	}

	// RELATED VIDEOS
	var images = document.evaluate(".//img[@class='vimg90' and @onload]", document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (!images) return;
	for (var i = 0; i < images.snapshotLength; i++)
	{
		var img = images.snapshotItem(i);
		var onload = img.getAttribute("onload");
		img.src = onload.match(/http:\/\/[^']+/)[0];
	}
}

function getScripts()
{
	var scripts = document.evaluate(".//script", document, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (!scripts) return [];
	return scripts;
}

try
{
	main();
}
catch(e)
{
}
