
/*
------- CHANGELOG --------------------------------------------------------------

	2007-09-15  Kim A. Brandt <kimabrandt@gmx.de>
	* 12295.user.js (META REFRESH): Allow direct redirection to the url
	specified in the meta-content attribute.
	(FRAME REDIRECTION): Allow direct redirection to the source specified in
	the only (there is only one) frame-src attribute.
	(URL REDIRECTION): Allow direct redirection to the last url that is
	embedded in another url.

	2007-09-17  Kim A. Brandt <kimabrandt@gmx.de>
	* 12295.user.js (META REFRESH): Replaced the `indexOf' with the `search'
	function since some links are treated case sensitive by the servers!?
	(skipRedirect): Added tmp variable for the same reason.
	(isURL): Added prev variable to backtrack to the previous url before
	unescaping it. There could be spaces or suchlike in the url which need
	to be escaped.

------- RESOURCES --------------------------------------------------------------

	URL redirection
	http://en.wikipedia.org/wiki/URL_redirection
*/

const URI = /^[a-z][a-z0-9+-.]*:((\/\/((([a-z0-9-._~!$&'()*+,;=:]|%[a-f0-9]{2})*@)?((\[((([a-f0-9]{1,4}:){6}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(::([a-f0-9]{1,4}:){5}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(([a-f0-9]{1,4})?::([a-f0-9]{1,4}:){4}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|((([a-f0-9]{1,4}:)?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:){3}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(((([a-f0-9]{1,4}:){1,2})?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:){2}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(((([a-f0-9]{1,4}:){1,3})?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(((([a-f0-9]{1,4}:){1,4})?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(((([a-f0-9]{1,4}:){1,5})?[a-f0-9]{1,4})?::[a-f0-9]{1,4})|(((([a-f0-9]{1,4}:){1,6})?[a-f0-9]{1,4})?::))\])|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])|([a-z0-9-._~!$&'()*+,;=]|%[a-f0-9]{2})*)(:[0-9]+)?)(\/([a-z0-9-._~!$&'()*+,;=:@]*|%[a-f0-9]{2})*)*)|(\/(([a-z0-9-._~!$&'()*+,;=:@]+|%[a-f0-9]{2})+(\/([a-z0-9-._~!$&'()*+,;=:@]*|%[a-f0-9]{2})*)*)?)|(([a-z0-9-._~!$&'()*+,;=:@]+|%[a-f0-9]{2})+(\/([a-z0-9-._~!$&'()*+,;=:@]*|%[a-f0-9]{2})*)*))(\?([a-z0-9-._~!$&'()*+,;=:@/?]|%[a-f0-9]{2})*)?(#([a-z0-9-._~!$&'()*+,;=:@/?]|%[a-f0-9]{2})*)?$/i;
const ABS_PATH = /^(\/(([a-z0-9-._~!$&'()*+,;=:@]+|%[a-f0-9]{2})+(\/([a-z0-9-._~!$&'()*+,;=:@]*|%[a-f0-9]{2})*)*)?)(\?([a-z0-9-._~!$&'()*+,;=:@/?]|%[a-f0-9]{2})*)?(#([a-z0-9-._~!$&'()*+,;=:@/?]|%[a-f0-9]{2})*)?$/i;
const REL_PATH = /^((([a-z0-9-._~!$&'()*+,;=:@]+|%[a-f0-9]{2})+(\/([a-z0-9-._~!$&'()*+,;=:@]*|%[a-f0-9]{2})*)*))(\?([a-z0-9-._~!$&'()*+,;=:@/?]|%[a-f0-9]{2})*)?(#([a-z0-9-._~!$&'()*+,;=:@/?]|%[a-f0-9]{2})*)?$/i;

function main()
{
	// META REFRESH
	var metas = document.evaluate("./html/head/meta[translate(@http-equiv,'EFHRS','efhrs')='refresh' and contains(translate(@content,'LUR','lur'),'url=')]", document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	if (metas && metas.snapshotLength > 0)
	{
		var content = metas.snapshotItem(0).getAttribute("content");		
		var index = content.search(/url=/i);
		var url = getURL(content.substring(index+4));
		if (locationReplace(url)) return;
	}

	// FRAME REDIRECTION
	var frames = document.evaluate(".//frame[@src]", document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (frames && frames.snapshotLength == 1)
	{
		var url = getURL(frames.snapshotItem(0).src);
		if (locationReplace(url)) return;
	}

	// URL REDIRECTION
//	var anchors = document.evaluate(".//a[starts-with(translate(@href,'HPT','hpt'),'http://') and contains(translate(substring(@href,5),'HPT','hpt'),'http')]", document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null); // `starts-with' DOESN'T WORK WITH GREASEMONKEY!?
	var anchors = document.evaluate(".//a[contains(translate(@href,'HPT','hpt'),'http://') and contains(translate(substring(@href,5),'HPT','hpt'),'http')]", document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (anchors && anchors.snapshotLength > 0) for (var i = 0; i < anchors.snapshotLength; i++) skipRedirect(anchors.snapshotItem(i));
}

function skipRedirect(element)
{
	var href = element.getAttribute("href");
	var tmp = href.toLowerCase();
	var index = tmp.lastIndexOf("http");
	var url;
	do
	{
		if (index <= 0) return;
		if (url = isURL(href, index)) break;
	} while (index = tmp.lastIndexOf("http", index-1));
	if (index > 0) element.setAttribute("href", url); // SKIP REDIRECT
}

function isURL(href, index)
{
	var tmp = href.substring(index).match(/^[^?#&]+/);
	if (!tmp) return null;
	tmp = tmp[0];
	var prev;
	while (tmp.indexOf("%") > -1)
	{
		prev = tmp;
		tmp = unescape(tmp);
	}
	var url = tmp.match(URI);
	if (url) return url[0];
	url = prev.match(URI);
	if (url) return url[0];
	return null;
}

function getURL(tmp)
{
	var protocol = window.location.protocol;
	var host = window.location.host;
	if (tmp.match(URI)) return tmp;
	else if (tmp.match(ABS_PATH)) return protocol + "//" + host + tmp;
	else if (tmp.match(REL_PATH))
	{
		var pathname = window.location.pathname;
		pathname = pathname.substring(0, pathname.lastIndexOf("/"));
		return protocol + "//" + host + pathname + "/" + tmp;
	}
	return null;
}

function locationReplace(url)
{
	if (url)
	{
		window.location.replace(url);
		return true;
	}
	else return false;
}

main();
